local addon, rch = ...

function rch.windowOptionsConfig()
	rch.window:SetVisible(false)
	rch.windowOptions:ClearAll()
	rch.windowOptions:SetPoint("CENTER", UIParent, "CENTER")
	rch.windowOptions:SetWidth(500)
	rch.windowOptions:SetHeight(400)
	rch.windowOptionsFrame:SetPoint("TOPLEFT", rch.windowOptions:GetContent(), "TOPLEFT", 185, 85)
	rch.windowOptionsFrame:SetBackgroundColor(0, 0, 0, 0.5)
	rch.windowOptionsFrame:SetLayer(0)
	rch.windowOptionsFrame:SetWidth(260)
	rch.windowOptionsFrame:SetHeight(100)

	rch.windowSelectLang:SetPoint("TOPLEFT", rch.windowOptions:GetContent(), "TOPLEFT", 10, 50)
	rch.windowSelectLang:SetWidth(140)
	rch.windowSelectLang:SetBorder(1, 1, 1, 1, 1)
	rch.windowSelectLang:SetItems(rch.SelectLang)
	rch.windowSelectLang:GetItems()
	rch.windowSelectLang:SetSelectedIndex(rchSavedValues.lang)
	rch.windowFontSlider:SetPoint("TOPLEFT", rch.windowOptions:GetContent(), "TOPLEFT", 200, 50)
	rch.windowFontSlider:SetRange(12, 20)
	rch.windowFontSlider:SetPosition(rchSavedValues.font)
	rch.windowColorSliderR:SetPoint("TOPLEFT", rch.windowOptions:GetContent(), "TOPLEFT", 200, 200)
	rch.windowColorSliderR:SetRange(0, 100)
	rch.windowColorSliderG:SetPoint("TOPLEFT", rch.windowOptions:GetContent(), "TOPLEFT", 200, 230)
	rch.windowColorSliderG:SetRange(0, 100)
	rch.windowColorSliderB:SetPoint("TOPLEFT", rch.windowOptions:GetContent(), "TOPLEFT", 200, 260)
	rch.windowColorSliderB:SetRange(0, 100)
	rch.windowColorSelector:SetPoint("TOPLEFT", rch.windowOptions:GetContent(), "TOPLEFT", 10, 210)
	rch.windowColorSelector:SetWidth(140)
	rch.windowColorSelector:SetBorder(1, 1, 1, 1, 1)
	local cselectlist = {"Uncommon", "Rare", "Epic", "Relic"}
	rch.windowColorSelector:SetItems(cselectlist)
	rch.windowColorSelector:SetSelectedIndex(1)
	rch.windowSelectLang:SetFontSize(rchSavedValues.font)
	rch.windowColorSelector:SetFontSize(rchSavedValues.font)
	rch.windowColorSliderR:SetPosition(rchColorValues[1].r * 100)
	rch.windowColorSliderG:SetPosition(rchColorValues[1].g * 100)
	rch.windowColorSliderB:SetPosition(rchColorValues[1].b * 100)
	for i = 1, 4 do
		rch.windowOptionsText[i]:SetPoint("TOPLEFT", rch.windowOptionsFrame, "TOPLEFT", 5, (1 + (25 * (i - 1))))
		rch.windowOptionsText[i]:SetFontSize(rchSavedValues.font)
		rch.windowOptionsText[i]:SetFontColor(rchColorValues[i].r, rchColorValues[i].g, rchColorValues[i].b )
		rch.windowOptionsText[i]:SetText(rch.OptionsText[i])
		rch.windowOptionsText[i]:SetLayer(1)
		rch.windowOptionsText[i]:SetWidth(260)
		rch.windowOptionsText[i]:SetHeight(50)
		rch.windowQualityCheck[i]:SetPoint("TOPLEFT", rch.windowOptions, "TOPLEFT", 170, 270 + (25 * (i - 1)))
		rch.windowQualityCheck[i]:SetChecked(rchQualityEnabled[i])
		rch.windowQualityCheck[i].Event.CheckboxChange = function()
			rchQualityEnabled[i] = rch.windowQualityCheck[i]:GetChecked()
		end

	end
	
	rch.windowOptions:SetCloseButtonVisible(true)
	rch.windowOptions:SetVisible(true)
	
	rch.windowColorSelector.Event.ItemSelect = function(view, item)
		local sel = rch.windowColorSelector:GetSelectedIndex()
		if sel == nil then sel = 1 end
		rch.SliderPosition(sel)
	end

	rch.windowSelectLang.Event.ItemSelect = function(view, item)
	if item == "English" then rchSavedValues.lang = 1 end
	if item == "German" then rchSavedValues.lang = 1 end --2 When German Files are translated
	if item == "French" then rchSavedValues.lang = 1 end --3 When French Files are translated
	rch.setLanguageText(rchSavedValues.lang)
	rch.UpdateRuneList(rch.lastsorted)
	end
	function rch.SliderPosition(index)
		rch.windowColorSliderR:SetPosition(rchColorValues[index].r * 100)
		rch.windowColorSliderG:SetPosition(rchColorValues[index].g * 100)
		rch.windowColorSliderB:SetPosition(rchColorValues[index].b * 100)
	end
	function rch.windowFontSlider.Event.SliderChange()
		rchSavedValues.font = rch.windowFontSlider:GetPosition()
		for i = 1, 4 do
			rch.windowOptionsText[i]:SetFontSize(rchSavedValues.font)
		end
			rch.windowSelectLang:SetFontSize(rchSavedValues.font)
			rch.windowColorSelector:SetFontSize(rchSavedValues.font)
			rch.windowList:SetFontSize(rchSavedValues.font)
			rch.windowListFrame:SetHeight(rch.windowList:GetHeight() + 2)
			rch.windowSelectLevel:SetFontSize(rchSavedValues.font)
			rch.windowSelectCraft:SetFontSize(rchSavedValues.font)
		local offset = 0
		for i = 1, 60 do
			rch.pText[i]:SetPoint("TOPLEFT",rch.windowlFrame,"TOPLEFT", 10, offset)
			rch.pText[i]:SetFontSize(rchSavedValues.font)
			rch.pitem2[i]:SetPoint("TOPLEFT",rch.windowlFrame,"TOPLEFT",(200 + (rchSavedValues.font * (rchSavedValues.font - 11))), offset)
			rch.pitem2[i]:SetFontSize(rchSavedValues.font)
			rch.pitem3[i]:SetPoint("TOPLEFT",rch.windowlFrame,"TOPLEFT", (380 + (rchSavedValues.font * (rchSavedValues.font - 11))), offset)
			rch.pitem3[i]:SetFontSize(rchSavedValues.font)
			rch.pitem4[i]:SetPoint("TOPLEFT",rch.windowlFrame,"TOPLEFT", (580 + (rchSavedValues.font * (rchSavedValues.font - 11))), offset)
			rch.pitem4[i]:SetFontSize(rchSavedValues.font)
			rch.pback[i]:SetPoint("TOPLEFT",rch.windowlFrame,"TOPLEFT", 0, offset)
			rch.pback[i]:SetWidth(rch.windowlFrame:GetWidth())
			rch.pback[i]:SetHeight(rch.pText[i]:GetHeight())
			offset = offset + (rchSavedValues.font + 3)
		end
	end

	function rch.windowColorSliderR.Event.SliderChange()
		local sel = rch.windowColorSelector:GetSelectedIndex()
			rchColorValues[sel].r = (rch.windowColorSliderR:GetPosition() / 100)
			rch.windowOptionsText[sel]:SetFontColor(rchColorValues[sel].r, rchColorValues[sel].g, rchColorValues[sel].b)
	end

	function rch.windowColorSliderG.Event.SliderChange()
		local sel = rch.windowColorSelector:GetSelectedIndex()
			rchColorValues[sel].g = (rch.windowColorSliderG:GetPosition() / 100)
			rch.windowOptionsText[sel]:SetFontColor(rchColorValues[sel].r, rchColorValues[sel].g, rchColorValues[sel].b)
	end

	function rch.windowColorSliderB.Event.SliderChange()
		local sel = rch.windowColorSelector:GetSelectedIndex()
			rchColorValues[sel].b = (rch.windowColorSliderB:GetPosition() / 100)
			rch.windowOptionsText[sel]:SetFontColor(rchColorValues[sel].r, rchColorValues[sel].g, rchColorValues[sel].b)
	end

	function rch.windowOptions.Event.Close()
		rch.resizeWindow()
		rch.window:SetVisible(true)
		rch.UpdateRuneList(rch.lastsorted)
	end

end

