local addon, rch = ...


local lastUnitUpdate = 0
local function getThrottle()
	local now = Inspect.Time.Frame()
	elapsed = now - lastUnitUpdate
	if (elapsed >= (1)) then lastUnitUpdate = now return true end
end
function rch.DetailsUpdate()
	if rch.window:GetVisible() == false then return end
	timer = getThrottle()
	if not timer then return end
	for key, val in pairs(rch.runetable) do
		if rch.runetable[key].idok == "not" then
			local ok, detail = pcall(rch.InspectItemDetail, rch.runetable[key].id)
			if((ok and detail)) then rch.runetable[key].idok = "ok"	end
			if(not (ok and detail)) then end
		end
	end
end
function rch.UpdateRuneList(sorted)
	for i = 1, 60 do
		rch.pText[i]:SetVisible(false)
		rch.pitem2[i]:SetText("")
		rch.pitem3[i]:SetText("")
		rch.pitem4[i]:SetText("")
		rch.pback[i]:SetBackgroundColor(0,0,0,0)
		rch.pback[i]:SetWidth(rch.windowlFrame:GetWidth())
		rch.pback[i]:SetHeight(rch.pText[i]:GetHeight())
	end
	pOld = ""
	rch.lastsorted = sorted
	pTable = {}
	if rch.craftsel == 1 then pTable = rch.LangRunes[rchSavedValues.lang] end
	if rch.craftsel == 2 then pTable = rch.LangRunes[rchSavedValues.lang] end
	if rch.craftsel == 3 then pTable = rch.LangAugs[rchSavedValues.lang] end
	rch.runetable = {}
	for k, v in pairs(pTable) do
		if v.stat then fstat = string.find(v.stat, sorted) end
		if v.slot then fslot = string.find(v.slot, sorted) end
		if v.itemid ~= nil then pId = v.itemid else pId = nil end
		if fstat or fslot then
			if (v.slot == sorted) and (v.name == pOld) then
				--Dupe Detection
			elseif (rch.craftsel == 1 or rch.craftsel == 2) and ((tonumber(v.reqlvl) < rch.sortminlvl) or (tonumber(v.reqlvl) > rch.sortmaxlvl)) then
			--Req lvl filter
			elseif (rch.craftsel == 3) and ((tonumber(v.reqlvl) < rch.sortminlvl) or (tonumber(v.reqlvl) > rch.sortmaxlvl)) then
			--Req lvl filter
			elseif rchQualityEnabled[tonumber(v.quality)] == false then
			else
			pSlot = v.slot
			if v.slot == "OneHand/OffHand/Ranged/Seal" then pSlot = "1H/OH/Ranged/Seal" end
			if v.slot == "OneHand/OffHand/Ranged" then pSlot = "1H/OH/Ranged" end
				table.insert(rch.runetable, {name = v.name, id = pId, idok = "not", slot = pSlot, stat = v.stat, statname = v.statname, quality = v.quality, source = v.source, reqlvl = v.reqlvl, source = v.source, r = rchColorValues[tonumber(v.quality)].r, g = rchColorValues[tonumber(v.quality)].g, b = rchColorValues[tonumber(v.quality)].b})
				pOld = pName
			end
		end
	end
	for key, val in pairs(rch.runetable) do
		rch.pText[key]:SetFontColor(val.r, val.g, val.b)
		rch.pText[key]:SetText(val.name)
		rch.pText[key]:SetVisible(true)
		rch.pback[key]:SetHeight(rch.pText[key]:GetHeight())
		if math.fmod(key, 2) ~= 0 then rch.pback[key]:SetBackgroundColor(0,0,0,.4) else end
		if rch.craftsel == 1 then rch.pitem2[key]:SetText(val.slot)	else rch.pitem2[key]:SetText("") end
		if rch.craftsel == 3 then rch.pitem3[key]:SetText(val.stat) else rch.pitem3[key]:SetText(val.statname) end
		rch.pitem4[key]:SetText(val.source)
	end
end

function rch.TooltipShow(pos)
	if rch.window:GetVisible() == false then return end
	if pos ~= nil and rch.runetable[pos].id ~= nil then
		if rch.runetable[pos].idok == "ok" then
			rch.tooltipval = pos
			Command.Tooltip(rch.runetable[pos].id)
		end
	end
end
function rch.TooltipHide(pos)
	if rch.window:GetVisible() == false then return end
	if rch.tooltipval == pos then Command.Tooltip(nil) end
end

function rch.setLanguageText(i)
	rch.window.title2a:SetText(rch.UIStrings[i].title2a)
	rch.window.title2b:SetText(rch.UIStrings[i].title2b)
	rch.window.title2c:SetText(rch.UIStrings[i].title2c)
	if rch.craftsel == 1 then
	end
	if rch.craftsel == 2 then
		rch.window.title2b:SetText("")
	end
	if rch.craftsel == 3 then
		rch.window.title2b:SetText("")
	end
	temp = (i + (3 * (rch.craftsel -1)))
	rch.windowList:SetItems(rch.SelectStrings[temp])
	rch.windowList:GetItems()
	rch.windowListFrame:SetHeight(rch.windowList:GetHeight() + 2)
	rch.windowList:SetSelectedIndex(1)
end
local function rchloadSettings()
	rch.windowOptions:SetVisible(false)
	print ("Welcome to Runecraft Helper! \n Use /rch to toggle the display.")
	if rchSavedValues == nil then
		rchSavedValues = {windowstate = "show", locmainx = 0, locmainy = 0, locbutx = 0, locbuty = 0, font = 14, lang = 1}
		rchSavedValues.locmainx = ((UIParent:GetRight() / 2) - 400)
		rchSavedValues.locmainy = ((UIParent:GetBottom() / 2) - 500)
		rchSavedValues.locbutx = ((UIParent:GetRight() / 2) - 32)
		rchSavedValues.locbuty = ((UIParent:GetBottom() / 2) - 32)
	end
	if rchColorValues == nil then
		rchColorValues = {{r = 0, g = 0.8, b = 0}, {r = 0.15, g = 0.5, b = 1}, {r = 0.7, g = 0.3, b = 1}, {r = 1, g = 0.5, b = 0}}
	end
	if rchSavedValues.windowstate == 'hide' then
		print (rch.UIStrings[rchSavedValues.lang].close)
	else
		rchSavedValues.windowstate = 'show'
	end
	if rchColorValues[4] == nil then rchColorValues[4] = {r = 1, g = 0.5, b = 0} end
	rch.CreateButton()
	rch.CreateWindow()
	rch.CreateTableList()
end

local function rchSlashCommand(hEvent, params)
	if params == "reset"  then
		rchSavedValues = {windowstate = "show", locmainx = 0, locmainy = 0, locbutx = 0, locbuty = 0, font = 14, lang = 1}
		rchSavedValues.locmainx = ((UIParent:GetRight() / 2) - 400)
		rchSavedValues.locmainy = ((UIParent:GetBottom() / 2) - 500)
		rchSavedValues.locbutx = ((UIParent:GetRight() / 2) - 32)
		rchSavedValues.locbuty = ((UIParent:GetBottom() / 2) - 32)
		rch.window:SetPoint("TOPLEFT", rch.context, "TOPLEFT", rchSavedValues.locmainx, rchSavedValues.locmainy)
		rch.miniButton:SetPoint("TOPLEFT", rch.context, "TOPLEFT", rchSavedValues.locbutx, rchSavedValues.locbuty)
		rchColorValues = {{r = 0, g = 0.8, b = 0}, {r = 0.15, g = 0.5, b = 1}, {r = 0.7, g = 0.3, b = 1}, {r = 1, g = 0.5, b = 0}}
		print ("Runecraft Helper setting have been reset!")
		rch.window:SetVisible(true)
	else
	if rchSavedValues.windowstate then
		if rchSavedValues.windowstate == 'hide' then
			rch.window:SetVisible(true)
			rchSavedValues.windowstate = 'show'
		else
			rchSavedValues.windowstate = 'show'
			rch.window:SetVisible(false)
			rchSavedValues.windowstate = 'hide'
			print (rch.UIStrings[rchSavedValues.lang].close)
		end
	end
	end
end
Command.Event.Attach(Command.Slash.Register("rch"), rchSlashCommand, "rchSlashCommand")
Command.Event.Attach(Event.Addon.Startup.End, rchloadSettings, "rchloadSettings")
Command.Event.Attach(Event.System.Update.Begin, rch.DetailsUpdate,  "UpdateDetails")

