local addon, rch = ...

-- Rendering rch.context
--rch = {}
rch.context = UI.CreateContext("Context")
rch.window = UI.CreateFrame("SimpleWindow", "MainWindow", rch.context)
rch.windowOptionsButton = UI.CreateFrame("RiftButton", "OptionsWindowButton", rch.window)
rch.windowOptions = UI.CreateFrame("SimpleWindow", "OptionsWindow", rch.context)
rch.windowOptionsFrame = UI.CreateFrame("Frame", "OptionsWindowFrame", rch.windowOptions)
rch.windowlFrameScroll = UI.CreateFrame("SimpleScrollView", "ListFrame", rch.window)
rch.windowlFrame = UI.CreateFrame("Frame", "ListFrame", rch.windowlFrameScroll)
rch.windowListFrame = UI.CreateFrame("SimpleScrollView", "List", rch.window)
rch.windowList = UI.CreateFrame("SimpleList", "List", rch.window)
rch.windowSelectCraft = UI.CreateFrame("SimpleList", "List", rch.window)
rch.windowSelectLevel = UI.CreateFrame("SimpleSelect", "List", rch.window)
rch.windowSelectLang = UI.CreateFrame("SimpleList", "List", rch.windowOptions)
rch.windowFontSlider = UI.CreateFrame("SimpleSlider", "Font", rch.windowOptions)
rch.windowColorSliderR = UI.CreateFrame("SimpleSlider", "ColorR", rch.windowOptions)
rch.windowColorSliderG = UI.CreateFrame("SimpleSlider", "ColorG", rch.windowOptions)
rch.windowColorSliderB = UI.CreateFrame("SimpleSlider", "ColorB", rch.windowOptions)
rch.windowColorSelector = UI.CreateFrame("SimpleList", "ColorList", rch.windowOptions)
rch.windowQualityCheck = {}
rchQualityEnabled = {true, true, true, true}
rch.windowOptionsText = {}
for i = 1, 4 do
	rch.windowOptionsText[i] = UI.CreateFrame("Text", "Example"..i, rch.windowOptions)
	rch.windowQualityCheck[i] = UI.CreateFrame("RiftCheckbox", "Checkbox", rch.windowOptions)
end
rch.pText = {}
rch.pitem2 = {}
rch.pitem3 = {}
rch.pitem4 = {}
rch.pback = {}
rch.runetable = {}
rch.lastsorted = ""
rch.craftsel = 1
rch.lastsorted = "Dexterity"
rch.sortminlvl = 51
rch.sortmaxlvl = 60
rch.clickOffset = {x = 0, y = 0}
rch.InspectItemDetail = Inspect.Item.Detail
rch.tooltipval = false

function rch.CreateWindow()
	rch.window:SetPoint("TOPLEFT", UIParent, "TOPLEFT", rchSavedValues.locmainx, rchSavedValues.locmainy)
	rch.window:SetHeight(250 + (rchSavedValues.font * 33))
	rch.window:SetWidth(400 + (rchSavedValues.font * (60 - rchSavedValues.font)))
	rch.window:SetTitle("Runecraft Helper")
	rch.windowOptionsButton:SetPoint("TOPRIGHT", rch.window, "TOPRIGHT", -80, 40)
	rch.windowOptionsButton:SetText("Options")
	rch.windowOptionsButton:SetHeight(30)
	rch.windowOptionsButton:SetWidth(120)
	
	rch.windowlFrameScroll:SetBackgroundColor(0, 0, 0, 0.5)
	rch.windowlFrameScroll:SetPoint("TOPLEFT", rch.window, "TOPLEFT", 175, 100)
	rch.windowlFrameScroll:SetHeight(120 + (rchSavedValues.font * 33))
	rch.windowlFrameScroll:SetWidth(200 + (rchSavedValues.font * (60 - rchSavedValues.font)))

	rch.windowlFrame:SetHeight(200 + (rchSavedValues.font * 60))

	rch.windowListFrame:SetPoint("CENTERLEFT", rch.window:GetContent(), "CENTERLEFT", 10, 0) 
	rch.windowListFrame:SetWidth(140)
	rch.windowListFrame:SetHeight(325)
	rch.windowListFrame:SetBorder(1, 1, 1, 1, 1)

	rch.windowlFrameScroll:SetContent(rch.windowlFrame)
	
	rch.windowSelectCraft:SetPoint("TOPLEFT", rch.window:GetContent(), "TOPLEFT", 10, 20)
	rch.windowSelectCraft:SetWidth(140)
	rch.windowSelectCraft:SetBorder(1, 1, 1, 1, 1)
	rch.windowSelectCraft:SetItems(rch.SelectCraft[rchSavedValues.lang])
	rch.windowSelectCraft:GetItems()
	rch.windowSelectCraft:SetFontSize(rchSavedValues.font)
	rch.windowSelectCraft:SetSelectedIndex(1)

	rch.windowSelectLevel:SetPoint("BOTTOMLEFT", rch.window:GetContent(), "BOTTOMLEFT", 10, -20)
	rch.windowSelectLevel:SetFontSize(rchSavedValues.font)
	rch.windowSelectLevel:SetWidth(140)
	rch.windowSelectLevel:SetBorder(1, 1, 1, 1, 1)
	rch.windowSelectLevel:SetItems(rch.SelectLevel[rch.craftsel])
	rch.windowSelectLevel:GetItems()
	rch.windowSelectLevel:SetSelectedIndex(5)

	rch.windowList:SetItems(rch.SelectStrings[rchSavedValues.lang])
	rch.windowListFrame:SetContent(rch.windowList)
	rch.windowList:SetFontSize(rchSavedValues.font)
 	rch.windowListFrame:SetHeight(rch.windowList:GetHeight() + 2)
  
	rch.window.title2a = UI.CreateFrame("Text","title2a",rch.window)
	rch.window.title2a:SetPoint("TOPLEFT",rch.window,"TOPLEFT",185, 70)
	rch.window.title2a:SetLayer(2)
	rch.window.title2a:SetFontColor(1,0.84,0,1)
	rch.window.title2a:SetFontSize(16)
	rch.window.title2a:SetText(rch.UIStrings[rchSavedValues.lang].title2a)
	
	rch.window.title2b = UI.CreateFrame("Text","title2b",rch.window)
	rch.window.title2b:SetPoint("TOPLEFT",rch.window,"TOPLEFT",(420 + (rchSavedValues.font * (rchSavedValues.font - 11))), 70)
	rch.window.title2b:SetLayer(2)
	rch.window.title2b:SetFontColor(1,0.84,0,1)
	rch.window.title2b:SetFontSize(16)
	rch.window.title2b:SetText(rch.UIStrings[rchSavedValues.lang].title2b)
	
	rch.window.title2c = UI.CreateFrame("Text","title2c",rch.window)
	rch.window.title2c:SetPoint("TOPLEFT",rch.window,"TOPLEFT", (600 + (rchSavedValues.font * (rchSavedValues.font - 11))), 70)
	rch.window.title2c:SetLayer(2)
	rch.window.title2c:SetFontColor(1,0.84,0,1)
	rch.window.title2c:SetFontSize(16)
	rch.window.title2c:SetText(rch.UIStrings[rchSavedValues.lang].title2c)
	
	rch.window.title2d = UI.CreateFrame("Text","title2c",rch.window)
	rch.window.title2d:SetPoint("TOPLEFT",rch.window,"TOPLEFT", (800 + (rchSavedValues.font * (rchSavedValues.font - 11))), 70)
	rch.window.title2d:SetLayer(2)
	rch.window.title2d:SetFontColor(1,0.84,0,1)
	rch.window.title2d:SetFontSize(16)
	rch.window.title2d:SetText(rch.UIStrings[rchSavedValues.lang].title2e)
	
	rch.window:SetCloseButtonVisible(true)

	rch.windowOptionsButton:EventAttach(Event.UI.Input.Mouse.Left.Click, function()
		rch.windowOptionsConfig()
	end, "ButtonClick")
	
	rch.windowList.Event.ItemSelect = function(view, item)
		rch.UpdateRuneList(item)
		end
	rch.windowSelectCraft.Event.ItemSelect = function(view, item)
		if item == "Runecraft Stat" then
			rch.craftsel = 1
			rch.windowSelectLevel:SetItems(rch.SelectLevel[rch.craftsel])
			rch.windowSelectLevel:SetSelectedIndex(5)
			rch.lastsorted = "Dexterity"
		end
		if item == "Runecraft Slot" then
			rch.craftsel = 2
			rch.windowSelectLevel:SetItems(rch.SelectLevel[rch.craftsel])
			rch.windowSelectLevel:SetSelectedIndex(5)
			rch.lastsorted = "Helmet"
		end
		if item == "Augments" then
			rch.craftsel = 3
			rch.windowSelectLevel:SetItems(rch.SelectLevel[rch.craftsel])
			rch.windowSelectLevel:SetSelectedIndex(5)
			rch.lastsorted = "Dexterity"
		end
		rch.setLanguageText(rchSavedValues.lang)
		rch.UpdateRuneList(rch.lastsorted)
		end

	rch.windowSelectLevel.Event.ItemSelect = function(view, item)
		if rch.craftsel == 3 then
			rch.sortminlvl = tonumber(string.sub(item, string.find(item, "%d%d%d")))
			rch.sortmaxlvl = tonumber(string.sub(item, string.find(item, "%d%d%d")))
		else
			rch.sortminlvl = tonumber(string.sub(item, string.find(item, "%d%d")))
			rch.sortmaxlvl = tonumber(string.sub(item, string.find(item, "%d%d", 12)))
		end
		rch.UpdateRuneList(rch.lastsorted)
		end
		
	function rch.window.Event.Close()
			rchSavedValues.locmainx = rch.window:GetLeft()
			rchSavedValues.locmainy = rch.window:GetTop()
			print (rch.UIStrings[rchSavedValues.lang].close)
			rch.window:SetVisible(false)
			rchSavedValues.windowstate = 'hide'
	end

	rch.window:SetVisible(rchSavedValues.windowstate == 'show')
end

function rch.resizeWindow()
		rch.window:SetHeight(250 + (rchSavedValues.font * 33))
		rch.window:SetWidth(400 + (rchSavedValues.font * (60 - rchSavedValues.font)))
		rch.windowlFrameScroll:SetHeight(120 + (rchSavedValues.font * 33))
		rch.windowlFrame:SetHeight(200 + (rchSavedValues.font * 60))
		rch.windowlFrameScroll:SetWidth(200 + (rchSavedValues.font * (60 - rchSavedValues.font)))
		rch.window.title2b:SetPoint("TOPLEFT",rch.window,"TOPLEFT", (420 + (rchSavedValues.font * (rchSavedValues.font - 11))), 70)
		rch.window.title2c:SetPoint("TOPLEFT",rch.window,"TOPLEFT", (600 + (rchSavedValues.font * (rchSavedValues.font - 11))), 70)
		rch.window.title2d:SetPoint("TOPLEFT",rch.window,"TOPLEFT", (800 + (rchSavedValues.font * (rchSavedValues.font - 11))), 70)
end

function rch.CreateTableList()
	local offset = 0
	for i = 1, 60 do
		rch.pback[i] = UI.CreateFrame("Text","Frame"..i, rch.windowlFrame)
		rch.pback[i]:SetPoint("TOPLEFT",rch.windowlFrame,"TOPLEFT", 0, offset)
		rch.pback[i]:SetWidth(rch.windowlFrameScroll:GetWidth() - 30)
		rch.pback[i]:SetLayer(1)
		rch.pText[i] = UI.CreateFrame("Text","Name1"..i, rch.windowlFrame)
		rch.pText[i]:EventAttach(Event.UI.Input.Mouse.Cursor.In, function()	rch.TooltipShow(i) end, "ShowTooltip" )
		rch.pText[i]:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function() rch.TooltipHide(i) end, "ShowTooltip" )
		rch.pText[i]:SetPoint("TOPLEFT",rch.windowlFrame,"TOPLEFT", 10, offset)
		rch.pText[i]:SetFontSize(rchSavedValues.font)
		rch.pText[i]:SetVisible(false)
		rch.pText[i]:SetLayer(2)
		rch.pitem2[i] = UI.CreateFrame("Text","Name2"..i,rch.windowlFrame)
		rch.pitem2[i]:SetPoint("TOPLEFT",rch.windowlFrame,"TOPLEFT",(200 + (rchSavedValues.font * (rchSavedValues.font - 11))), offset)
		rch.pitem2[i]:SetFontSize(rchSavedValues.font)
		rch.pitem2[i]:SetLayer(2)
		rch.pitem3[i] = UI.CreateFrame("Text","Name3"..i,rch.windowlFrame)
		rch.pitem3[i]:SetPoint("TOPLEFT",rch.windowlFrame,"TOPLEFT", (380 + (rchSavedValues.font * (rchSavedValues.font - 11))), offset)
		rch.pitem3[i]:SetFontSize(rchSavedValues.font)
		rch.pitem3[i]:SetLayer(2)
		rch.pitem4[i] = UI.CreateFrame("Text","Name4"..i,rch.windowlFrame)
		rch.pitem4[i]:SetPoint("TOPLEFT",rch.windowlFrame,"TOPLEFT", (580 + (rchSavedValues.font * (rchSavedValues.font - 11))), offset)
		rch.pitem4[i]:SetFontSize(rchSavedValues.font)
		rch.pitem4[i]:SetLayer(2)
		offset = offset + (rchSavedValues.font + 3)
	end
end

function rch.CreateButton()
	rch.buttonBase = UI.CreateFrame("Texture", "rchmini Real Button", rch.context)
	rch.buttonBase:SetTexture("RunecraftHelper", "Textures\\minirch.dds")
	rch.buttonBase:SetWidth(64)
	rch.buttonBase:SetHeight(64)
if not MINIMAPDOCKER then
	rch.buttonBase:SetPoint("TOPLEFT", UIParent, "TOPLEFT", rchSavedValues.locbutx, rchSavedValues.locbuty)
end	
	rch.buttonBase.pressed = false
	rch.buttonBase.dragActive = false

	rch.buttonTooltip = UI.CreateFrame("Frame",  "Tooltip", rch.context)
	rch.buttonTooltip:SetWidth(180)
	rch.buttonTooltip:SetHeight(100)
	rch.buttonTooltip:SetLayer(1)
	rch.buttonTooltip:SetPoint("CENTER", rch.buttonBase, "CENTER")
	rch.buttonTooltip:SetVisible(false)
	rch.buttonTooltip:SetBackgroundColor(0, 0, 0, .3)
	
	rch.buttonTooltipText = UI.CreateFrame("Text", "window", rch.buttonTooltip)
	rch.buttonTooltipText:SetText("Runecraft Helper")
	rch.buttonTooltipText:SetPoint("TOPLEFT", rch.buttonTooltip, "TOPLEFT", 10, 8)
	rch.buttonTooltipText:SetFontColor(0.97, 0.78, 0.19)
	rch.buttonTooltipText:SetFontSize(15)
	
	rch.separator = UI.CreateFrame("Texture", "TooltipSeperator", rch.buttonTooltip)
	rch.separator:SetTexture("Rift", "header_divider.png.dds")
	rch.separator:SetPoint("TOPLEFT", rch.buttonTooltipText, "BOTTOMLEFT")
	rch.separator:SetWidth(180)
	rch.separator:SetHeight(20)
	rch.separator:SetLayer(4)
	
	rch.buttonTooltipBody = UI.CreateFrame("Text", "Runecraft Helper", rch.buttonTooltip)
	rch.buttonTooltipBody:SetLayer(4)
	rch.buttonTooltipBody:SetText(rch.UIStrings[rchSavedValues.lang].tooltip)
	rch.buttonTooltipBody:SetPoint("TOPLEFT", rch.separator, "BOTTOMLEFT")
	rch.buttonTooltipBody:SetFontColor(1, 1, 1)
	rch.buttonTooltipBody:SetFontSize(13)
	rch.buttonTooltipBody:SetWordwrap(true)

	rch.buttonBase:EventAttach(Event.UI.Input.Mouse.Cursor.In, function()
		rch.buttonTooltip:SetVisible(true)
	end, "ResizeMouseIn" )

	rch.buttonBase:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function()
		rch.buttonTooltip:SetVisible(false)
	end, "ResizeMouseOut" )

	rch.buttonBase:EventAttach(Event.UI.Input.Mouse.Left.Down, function()
		rch.buttonBase.pressed = true
	end, "ResizeMouseDown" )

	rch.buttonBase:EventAttach(Event.UI.Input.Mouse.Left.Up, function()
		if rch.buttonBase.pressed == true then
			if rchSavedValues.windowstate then
				if rchSavedValues.windowstate == 'hide' then
					rchSavedValues.windowstate = 'show'
					rch.window:SetVisible(true)
				elseif
					rchSavedValues.windowstate == 'show' then
					print (rch.UIStrings[rchSavedValues.lang].close)
					rchSavedValues.windowstate = 'hide'
					rch.window:SetVisible(false)
				end
			end
		rch.buttonBase.pressed = false
		end
	end, "ResizeMouseUp" )

	rch.buttonBase:EventAttach(Event.UI.Input.Mouse.Left.Upoutside, function()
		rch.buttonBase.pressed = false
		rch.buttonBase:SetTexture("RunecraftHelper", "Textures\\minirch.dds")
	end, "ResizeMouseOuside" )

	--start minibutton drag
	if MINIMAPDOCKER then
		MINIMAPDOCKER.Register("RunecraftHelper", rch.buttonBase)
	else
		rch.buttonBase:EventAttach(Event.UI.Input.Mouse.Right.Down, function()
			rch.buttonBase.dragActive = true
			local mouseStatus = Inspect.Mouse()
			rch.clickOffset["x"] = mouseStatus.x - rchSavedValues.locbutx
			rch.clickOffset["y"] = mouseStatus.y - rchSavedValues.locbuty
		end, "ResizeMouseOuside" )
	
		rch.buttonBase:EventAttach(Event.UI.Input.Mouse.Right.Up, function()
			rch.buttonBase.dragActive = false
		end, "ResizeMouseOuside" )
	
		rch.buttonBase:EventAttach(Event.UI.Input.Mouse.Cursor.Move, function(frame, hEvent,x,y)
			if rch.buttonBase.dragActive == true then
				rchSavedValues.locbutx = x - rch.clickOffset["x"]
				rchSavedValues.locbuty = y - rch.clickOffset["y"]	
				rch.buttonBase:SetPoint("TOPLEFT", rch.context, "TOPLEFT", rchSavedValues.locbutx, rchSavedValues.locbuty)
			end
		end, "ResizeMouseOuside" )
	end
end

